<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">
<html>

<head>
<meta http-equiv="Content-Type"
content="text/html; charset=iso-8859-1">
<meta name="FORMATTER" content="Microsoft FrontPage 2.0">
<meta name="GENERATOR" content="Microsoft FrontPage 2.0">
<title>Visual FoxPro Database Publishing</title>
<base target="_top">
</head>

<body background="../Images/whitwav.jpg" bgcolor="#FFFFFF">

<p><font color="#800040" size="6" face="Arial"><strong><img
src="../Images/foxhead.gif" align="right" hspace="0" width="231"
height="164"></strong></font><font color="#800040" size="6"
face="Arial"><strong>Database Publishing on the Internet with
Visual FoxPro</strong></font></p>

<h3><font face="Arial"><strong>By Rick Strahl</strong></font> </h3>

<p><a href="http://www.west-wind.com"><font size="3">http://www.west-wind.com/</font></a><font
size="3"> </font></p>

<p><font size="3"><em>Revised session notes from my 1996 Visual
FoxPro DevCon session.<br>
Updated 02/10/1997</em></font></p>

<ul>
    <li><a href="#WHY">Why build Web Applications</a></li>
    <li><a href="#LIMITATIONS">Limitations of Web Applications</a></li>
    <li><a href="#ACTIVEX">How the Active Web works</a></li>
    <li><a href="#START">What you need to get started</a></li>
    <li>Tools to Connect Visual FoxPro Data<ul>
            <li><a href="#DENALI">Microsoft Active Server Pages
                (IIS 3.0)</a></li>
            <li><a href="#FOXISAPI">FoxISAPI</a></li>
            <li><a href="#WEBCONNECTION">West Wind Web Connection</a></li>
        </ul>
    </li>
</ul>

<p><a href="VFPInternet.zip">Download this document (HTML)</a><br>
<a href="vfpweb.doc">Download Word '97 Document</a><a
href="VFPInternet.zip"><br>
</a><a href="vfpweb.ppt">Download Powerpoint '97 slides</a></p>

<hr>

<p><font color="#800040" size="5" face="Arial"><b>Overview</b></font></p>

<blockquote>
    <blockquote>
        <p><font size="3">This white paper will walk you through
        some of the tools available to build Web based
        applications with Visual FoxPro. Focus will be on
        building server side applications by introducing some of
        the tools that can take advantage of Visual FoxPro data
        and code to build high performance backends. </font></p>
        <p><font size="3">This paper will cover the following
        areas:</font></p>
    </blockquote>
    <blockquote>
        <ul>
            <li><font size="3">Overview of Web Technology with
                focus on building backend applications that
                connect to databases and Visual FoxPro in
                particular.</font></li>
            <li><font size="3">Review the hardware and software
                required to build Web based applications.</font></li>
            <li><font size="3">Using Microsoft Active Server (IIS
                3.0) to access FoxPro data via ODBC.</font></li>
            <li><font size="3">Integrating Visual FoxPro with
                Active Server via Visual FoxPro Automation
                Servers.</font></li>
            <li><font size="3">Using FoxISAPI to build Visual
                FoxPro Automation servers that interface directly
                with Web links.</font></li>
            <li><font size="3">Using Web Connection to simplify
                Web application development using a Web
                Application framework for Visual FoxPro.</font></li>
        </ul>
    </blockquote>
</blockquote>

<p><font color="#800040" size="5" face="Arial"><b>Introduction</b></font></p>

<blockquote>
    <blockquote>
        <p><font size="3">Building applications that are
        integrated with Internet technology and can connect
        databases to Web sites will likely become an important
        aspect in your software development in the future, if it
        hasn't become so already. We're just at the beginning of
        the move toward 'Active' Web content and while we'll
        surely see improvements in the tools available down the
        line, applications built with Visual FoxPro can provide
        extraordinary power, versatility and speed using standard
        PC hardware to drive high powered Web sites today.</font></p>
    </blockquote>
    <blockquote>
        <p><font face="Arial"><b>Internet Development is
        exploding</b></font></p>
    </blockquote>
    <blockquote>
        <p><font size="3">People are flocking to the Internet and
        the World Wide Web in particular by the millions. Because
        of the both the hype and the actual traffic on the 'Net,
        the Internet is an exploding market as businesses are
        trying to integrate the Internet into their existing
        business strategies.</font></p>
        <p><font size="3">There is tremendous demand for
        developers who can build the dynamic content necessary to
        build truly useful, distributed business applications
        that can run over the open Internet or the local
        Intranet.</font></p>
    </blockquote>
    <blockquote>
        <p><font face="Arial"><b><i>Active,</i></b><b> Database
        Applications are in high demand</b></font></p>
    </blockquote>
    <blockquote>
        <p><font size="3">Database applications are the key to
        building <i>active</i> Internet applications. Until
        recently static content via plain HTML pages has been the
        standard fare on the World Wide Web. However, for
        conveying lots of information the static HTML concept
        falls apart quickly and becomes a maintenance nightmare.</font></p>
        <p><font size="3">The true potential of the Web lies in
        giving users access to data that is always up to date,
        allows them to see only what they chose to look at by
        allowing the data to be filtered and queried to display
        only small, appropriately sized chunks at a time.</font></p>
    </blockquote>
    <blockquote>
        <p><font face="Arial"><b>Visual FoxPro is ready for the
        Internet today </b></font></p>
    </blockquote>
    <blockquote>
        <p><font size="3">Visual FoxPro is more than ready for
        this challenge. I've been involved in building several
        high volume Web sites that use Visual FoxPro as the
        database backend. Not only did Visual FoxPro perform
        extremely well under heavy load, but it also allowed
        creation of applications in record time and with a budget
        that was a fraction of the nearest competitor&#146;s bid.</font></p>
        <p><font size="3">Visual FoxPro provides exceptional
        database access speed that's unrivaled by ODBC based
        tools and even full blown SQL servers in many
        circumstances. In addition you can leverage your existing
        FoxPro skills and code base to build quality applications
        with full featured logic using the data centric and
        object oriented, FoxPro language. If designed properly,
        applications can also be scaled to handle just about any
        request load scaling to multiple processors or even
        multiple servers on separate machines across a network.</font></p>
    </blockquote>
</blockquote>

<p><a name="WHY"><font color="#800040" size="5" face="Arial"><b>Why
build Web Applications?</b></font></a></p>

<blockquote>
    <blockquote>
        <p><font size="3">If you&#146;ve read through the
        computer trade papers or even the mainstream computer
        press you&#146;ve probably noticed that the Web is
        affecting just about every aspect of computing these
        days. Software developers and tool vendors alike are
        focusing on the Web as the next development platform.
        Clients are asking about Net technology and how they can
        take advantage of the &#145;distributed&#146; envrionment
        which the Web offers.</font></p>
        <p><font size="3">For better or worse, the Web is here to
        stay. There are a number of very important steps forward,
        but at the same time a few blems that take us a step back
        in the area of application development.<b> </b>In this
        section and the following one I&#146;d like to point out
        some of the strengths and weaknesses of Web based
        application development. </font></p>
        <p><font face="Arial"><b>Distribute widely, administer
        centrally</b></font></p>
    </blockquote>
    <blockquote>
        <p><font size="3">The Internet could become the ultimate
        client/server platform. It provides:</font></p>
        <ul>
            <li><b>Easy access from any network connection<br>
                </b>Web applications are accessible from any
                network connection using TCP/IP. As long as the
                network is not locked off intentionally with
                security measures, you can access the same
                application from anywhere within your company or
                even from the outside when you're on the road.</li>
            <li><b>Applications are maintained in one place<br>
                </b>While the application can be run from any
                network connection the server is centrally
                located and maintained. The application can be
                updated in one place and all clients
                automatically see the update next time the
                application is run. The application also does not
                need to be installed on the client in any way -
                no making sure all the DLLs are available etc.
                All the &#145;thin client&#146; needs is a
                compatible Web browser.</li>
            <li><b>Clear separation of client and server<br>
                </b>The Web provides a typical client/server
                implementation where the client has no direct
                access to the server's functionality but
                converses with the server via transactions. Since
                all processing happens on the server and only the
                result returns to the client limited network
                bandwidth.<br>
                <b><br>
                Note: </b>Visual FoxPro can act as a server in
                this type of Client/Server environment. The Web
                acts as the middleware that connects the client
                to the server.</li>
        </ul>
        <p><font face="Arial"><b>Universal Client Interface</b></font></p>
        <p><font size="3">The Web Browser is quickly becoming one
        of the killer applications that come around and change
        the computing environment. The quick acceptance of this
        interface is driving changes in software design that is
        moving more and more technology towards a Web based
        interface.</font></p>
        <ul>
            <li><b>Cross Platform Clients<br>
                </b>Cross platform issues have been short-changed
                by software developers for the longest time.
                Browsers are perhaps the first tool that bring
                the various operating systems and environments
                together and allow them to run the same
                applications.<br>
                Not only that, but you can build your application
                under Windows and expect people on Unix or Mac
                boxes to run them as is. Browsers make it
                possible to use whatever tool/platform you're
                comfortable with to build backend applications
                and still provide the cross platform capability.
                No extra development required.</li>
            <li><b>No hassle application updates</b><br>
                Applications can be updated on the server in a
                central location without having to touch the
                client machines.</li>
        </ul>
    </blockquote>
    <blockquote>
        <p><font face="Arial"><b>Application Platform of the
        future</b></font></p>
        <p><font size="3">Web browsers have brought about drastic
        changes in the software development field. One look at
        the latest software offerings from all the major software
        houses shows this in evidence: Internet connectivity and
        output options for creating HTML are evident wherever you
        look.</font></p>
        <p><font size="3">Development tools of all types are
        being provided with rudimentary tools to connect to the
        Internet. Microsoft has been previewing the next release
        of Internet Explorer which promises to integrate the Web
        browser directly into the operating system, where the
        desktop and integral file operations as well as access
        the network occur within a familiar browser interface.
        It's all geared towards integrating the Internet more
        transparently into the operating system. The hyperlinked
        nature of HTML (and the supporting ActiveX and Java
        technologies) makes it possible to transparently tie
        together the local machine, the interoffice workgroup or
        Intranet applications and the entire Internet. Welcome to
        the Network machine!</font></p>
    </blockquote>
</blockquote>

<p><a name="LIMITATIONS"><font color="#800040" size="5"
face="Arial"><b>Limitations of Web Applications</b></font></a></p>

<blockquote>
    <blockquote>
        <p><font size="3">There are many benefits to building an
        application that runs over the Web. But it's also
        extremely important to understand the limitations that
        you will face when building Web applications. They are
        not insurmountable, but they do require rethinking
        application development to some extent.</font></p>
        <p><font face="Arial"><b>Configuration Issues</b></font></p>
        <p><font size="3">Web Development is definitely more
        involved than building a standalone application using a
        visual tools such as Visual FoxPro or Visual Basic. For
        one thing you are dealing with a larger number of
        entities rather than just a single environment: The Web
        server, a connector application of some sort and the
        backend application, HTML pages and code. The complexity
        of how many different pieces are involved varies between
        the various approaches to development. Typically,
        you&#146;ll use a Browser to &#145;test&#146; your code,
        rather than simply running an application. </font></p>
        <p><font size="3">You need to have a basic understanding
        of how the components fit together in order to make all
        the pieces work together. The promise of component based
        software is starting to materialize with the Web, but as
        of now, it&#146;s not necessarily easy to make the
        components play nice.</font></p>
        <p><font face="Arial"><b>Interface limitations of HTML </b></font></p>
        <p><font size="3">Although typical HTML output can be
        very visual, there are various limitations in HTML that
        require re-thinking your typical database application
        user interface.</font></p>
    </blockquote>
    <blockquote>
        <ul>
            <li><b>No data access from client<br>
                </b>The browser has no direct access to the data
                which is maintained and accessed by the server.
                Data access is transaction based and any updates
                based on data retrieved from the server typically
                required the HTML document containing the form
                data to be reloaded.</li>
            <li><b>Limited object model/scripting<br>
                </b>Although both Microsoft and Netscape provide
                enhanced HTML form interfaces to their browsers
                via JavaScript and VBScript, the object model of
                these scripting engines are extremely limited
                compared to full blown visual tools and lack
                direct data access.</li>
            <li><b>Interface generated by the server<br>
                </b>If data access is required the HTML page is
                always loaded with data loaded from the server.
                Each time the data is updated on the server needs
                to reload the browser page and repopulate the
                data on the form.</li>
            <li><b>No easy way to print output</b><br>
                All output generated is HTML and there's no
                graceful way to print it other than using the
                Browser&#146;s Print option, which also has the
                side effect of re-loading the current page or
                script. There are some third party workarounds
                such as using Adobe Amber, but none are natively
                supported.</li>
        </ul>
    </blockquote>
    <blockquote>
        <p><font face="Arial"><b>Mostly non-visual Development</b></font></p>
        <p><font size="3">For the most part Web based application
        development is non-visual. While you can use visual HTML
        editors like FrontPage, Visual InterDev or WebEdit to
        build the HTML pages you display on browsers, the actual
        application code you write is usually transaction based
        involving mostly straight database code (queries,
        validations, inserts etc) and either generating the HTML
        via code or loading HTML pages from disk to evaluate
        embedded logic.</font></p>
        <p><font face="Arial"><b>Server based programming</b></font></p>
        <p><font size="3">Web application request handlers are
        basically server scripts, which are non-interactive and
        transaction based. Each link, or form request generates a
        hit on the server which in turn runs the request handler
        in response. Web programming usually involves:</font></p>
    </blockquote>
    <blockquote>
        <ul>
            <li>Validating user input on forms</li>
            <li>Running queries</li>
            <li>Generating HTML (or loading and outputting
                scripted HTML from disk)</li>
        </ul>
    </blockquote>
</blockquote>

<p><a name="ACTIVEX"><font color="#800040" size="5" face="Arial"><b>How
The Active Web works</b></font></a></p>

<blockquote>
    <blockquote>
        <p><font size="3">Figure 1.1 shows how Microsoft's Active
        architecture binds the client and server sides together.
        When looking at the figure keep in mind the strict
        separation between the client and server sides. Although
        some of the components like ActiveX controls and ISAPI
        extensions are Microsoft specific, the frameworks by
        Netscape and others look surprisingly similar.</font></p>
    </blockquote>
</blockquote>

<blockquote>
    <p><font size="3"><i><img src="ActiveWeb.gif" width="800"
    height="600"></i></font></p>
</blockquote>

<blockquote>
    <blockquote>
        <blockquote>
            <blockquote>
                <p><font size="3"><i>Figure 1.1 - Browser and Web
                Server relationship. Note the distinct line
                between the two.</i></font></p>
            </blockquote>
        </blockquote>
        <p><font face="Arial"><b>The Browser provides the Active
        interface</b></font></p>
        <p><font size="3">The Web browser provides the interface
        to an application or page viewer. The browser provides
        the interactive, visual face of a Web application. The
        interface consists mostly of HTML text along with
        graphics and basic input forms that can be embedded
        inside of HTML documents. All data input is handled via
        HTML formatted pages that are interpreted and then
        displayed by the browser.</font></p>
        <p><font size="3">Browser scripting languages like
        VBScript and JavaScript can be used to tie <i>some</i>
        logic to the HTML page. Scripting provides conditional
        output creation and an object/event model that allows
        manipulation of various interface and browser objects as
        well as responding to events fired by various form
        controls and form events. Keep in mind though: There is
        no direct data access from the client side, so you can't
        do data validation based on a table lookups unless all
        the information is somehow created into the HTML page
        directly. If you need data to be displayed in the browser
        the data needs to be generated into the HTML page at the
        server.</font></p>
        <p><font size="3">ActiveX Controls and Java Applets can
        be used to enhance Web pages with high power add-ins or
        operating system specific components. The controls can be
        manipulated using VBScript using a typical Property,
        Event, Method mechanism.</font></p>
        <p><font face="Arial"><b>Web Server provides data /
        application connectivity</b></font></p>
        <p><font size="3">On the other end of the connection sits
        the Web server. The Web server&#146;s main responsibility
        is, well, to serve content. Traditionally this has been
        static HTML pages that served from disk, but the Web
        server&#146;s role is expanding to provide the basic
        logic to interact with backend applications via the ISAPI
        interface.</font></p>
        <p><font size="3">The Web server is responsible for
        providing the database access and the connectivity to the
        actual processing application. The Web server itself
        knows nothing about applications and calls helper scripts
        (ISAPI extensions) to do the work for it. </font></p>
        <p><font face="Arial"><b>ISAPI is the building block for
        server side extensions</b></font></p>
        <p><font size="3">Typically the server calls an ISAPI or
        Common Gateway Interface (CGI) extension script which is
        responsible for returning HTTP compliant output. The <b>Internet
        Server API</b> (ISAPI) is a highly efficient Windows
        based API that allows extensions to run in the Web
        server's address space, which make them very fast and
        resource friendly. ISAPI extensions can either be
        self-contained and create the required output on their
        own or act as a connector and call another application to
        perform the actual request processing for it.</font></p>
        <p><font size="3">Keep in mind that ISAPI and CGI both
        are interfaces only and do not comprise a specific
        language implementation. ISAPI can be implemented in any
        language that can create true Win32 DLLs. CGI can be
        implemented by any language that supports creation of EXE
        files and can read and write to and from Standard Input
        and Output. </font></p>
        <p><font size="3">What&#146;s important to remember is
        that Visual FoxPro never runs as an ISAPI application
        directly &#150; it lacks the ability to create an ISAPI
        extension directly! Rather an ISAPI extension interacts
        with Visual FoxPro via some sort of messaging mechanism
        (OLE Automation, DDE, file based messaging etc.). If
        implemented correctly this process can be extremely fast
        and efficient. Both FoxISAPI and Web Connection use this
        approach to let you use Visual FoxPro to build
        application logic.</font></p>
        <p><font size="3">Figure 1.2 shows how ISAPI is the
        building block of most of the Web server extensions that
        Microsoft is creating. All the major tools provided for
        IIS by MS including the MS Internet Database Connector,
        and the ActiveX server framework are implemented via the
        ISAPI interface. FoxISAPI and Web Connection which will
        be discussed later on are also implemented using ISAPI as
        the connector interface and qualify as custom connector
        applications on the chart.</font></p>
    </blockquote>
</blockquote>

<blockquote>
    <p><font size="3"><img src="iis_isapi.gif" width="800"
    height="600"></font></p>
</blockquote>

<blockquote>
    <p><font size="3"><i>Figure 1.2 - Microsoft's Internet Server
    API is the building block for Web server extensions</i></font></p>
</blockquote>

<p><font color="#800040" size="5" face="Arial"><b>What you need
to get started</b></font></p>

<blockquote>
    <blockquote>
        <p><font size="3">Here's a short list of hardware and
        software required to run a Web application:</font></p>
        <p><font face="Arial"><b>Fast Pentium box
        (133Mhz/32-64megs)</b></font></p>
        <p><font size="3">While you can get by with smaller
        machines I would recommend this as a good baseline
        installation. I've run several Web sites on hardware as
        low as a 486-66 with 32 megs running NT 3.51 with decent
        results, but if your site gets more than a few thousand
        backend hits day the above is a good minimum. </font></p>
        <p><font size="3">For high volume sites multiprocessor
        boxes are the preferred way to go. Dual processors allow
        the Web server and Visual FoxPro to not compete for CPU
        cycles as much. Also, additional memory (128megs or more)
        can provide dramatic improvements in database (especially
        Read operations) and Web server performance as NT uses
        the memory for disk caching. </font></p>
        <p><font face="Arial"><b>Windows NT Server (recommended)</b></font></p>
        <p><font size="3">Windows NT Server is an excellent
        platform for running a Web server and for acting as an
        application server. Many Web servers will run on Windows
        95 and NT Workstation, but Windows 95 Web services are
        noticeably slower and NT Workstation has some serious
        licensing limitations that make it unsuitable for public
        Web server use, although it provides the same performance
        as NT Server.</font></p>
        <p><font size="3">Included with NT Server 4.0:</font></p>
    </blockquote>
    <blockquote>
        <ul>
            <li><b>TCP/IP Network Protocol<br>
                </b>TCP/IP must be loaded on the network or local
                machine in order to be able to take Web requests.<b>
                Note: </b>You don't need to have a network
                installed in order to test Web applications
                locally. You can tie TCP/IP to your network
                adapter, or if you don't have one to your Dialup
                Networking service.</li>
            <li><b>Web Server (MS IIS)<br>
                </b>Naturally, you'll need a Web server. NT 4.0
                ships with MS Internet Information Server 3.0,
                which is fast and powerful and hooked into
                Microsoft's Internet strategy. Other good servers
                available include Commerce Builder by the
                Internet Factory, Website by O'Reily and Purveyor
                by Process Software. All of these servers support
                ISAPI which will be the focus of our discussion
                here.<b><br>
                Note:</b> The following examples are for IIS. The
                Internet Database Connector and the Active Server
                Page are available only for IIS, while FoxISAPI
                works on all ISAPI based Web servers.</li>
        </ul>
    </blockquote>
    <blockquote>
        <p><font face="Arial"><b>Connector Interface/Application</b></font></p>
        <p><font size="3">You'll also need a 'connector'
        application that handles tying your FoxPro data the Web
        server. A connector application is a script tool that
        provides services for accessing another application or a
        scripting engine via an ISAPI DLL.</font></p>
        <p><font size="3">Active Server Pages uses an ISAPI
        extension to provide the interpreting of .ASP files in a
        specialty DLL. FoxISAPI and Web Connection both use an
        explicit connector DLL that is called directly of an HTML
        link.</font></p>
        <p><font face="Arial"><b>Web browser</b></font></p>
        <p><font size="3">In order to test your application you
        need a Web browser. I'll be using Internet Explorer 3.0
        here, but any late browser should do. Try and get one of
        the latest browsers from Microsoft or Netscape as they
        make up over 90% of the browser market and provide the
        most advanced features that you will encounter when
        cruising the Web.</font></p>
        <p><font face="Arial"><b>Basic HTML skills</b></font></p>
        <p><font size="3">You knew this was coming, right? Yes,
        in order to build Web applications you need to have at
        least a passing acquaintance with HTML. While it's
        possible to build HTML graphically using HTML editors
        like FrontPage, PageMill, NetObject etc, it's often
        required to generate HTML that gets inserted into
        existing documents - in order to do that you have to know
        a little about the various tags associated with text
        formatting. It's easy and best picked up by looking at
        the source of existing HTML pages.</font></p>
        <p><font face="Arial"><b>Everything can run on one box!</b></font></p>
        <p><font size="3">For development purposes you can set up
        a single machine to serve as your Web server and
        development platform. You don't need to be on network as
        you can access the Web server via its local IP address (<i>127.0.0.1</i>
        or <i>localhost</i>). </font></p>
    </blockquote>
</blockquote>

<p><a name="DENALI"><font color="#800040" size="5" face="Arial"><b>Active
Server Pages</b></font></a></p>

<blockquote>
    <blockquote>
        <p><font size="3">Active Server Pages (ASP) is part of
        Microsoft Internet Information Server 3.0 and can be
        downloaded from the Microsoft Web site (</font><a
        href="http://www.microsoft.com/iis"><font size="3">http://www.microsoft.com/iis</font></a><font
        size="3">). In short, Active Server Pages is a
        sophisticated, server side, object based scripting engine
        that allows mixing code and HTML in the page using
        (currently) Visual Basic Script or JavaScript.</font></p>
    </blockquote>
    <p><font size="3"><i><img src="aspobj.gif" width="800"
    height="600">Figure 1.3 &#150; Active Server is composed of a
    number of objects that are managed by the ASP.DLL ISAPI
    extension.</i></font></p>
    <blockquote>
        <p><font face="Arial"><b>Tight integration with IIS</b></font></p>
        <p><font size="3">ASP is actually a part of Internet
        Information server and installs when you upgrade IIS 2.0
        to 3.0. The integration into the server itself is very
        smooth by implementing an ISAPI extension with a script
        map to provide transparent support for interpreting any
        page with .ASP extension. This mechanism provides the
        illusion to the developer of simply editing an HTML pages
        and enhancing it with HTML.</font></p>
        <p><font size="3">Great care has been taken to provide an
        efficient environment for Active Server. The ISAPI
        extension handles multi-threading of requests and
        connection pooling for ODBC connections to provide fast
        access to dynamic content.</font></p>
        <p><font face="Arial"><b>Object Based Architecture</b></font></p>
        <p><font size="3">The entire Active Server framework is
        based on components that interact to provide access to
        the entire environment to the developer. Figure 1.3 shows
        the base components that ship with Active Server. The
        various components provide access to the vital pieces
        that are required to build sophisticated Web
        applications.</font></p>
        <p><font size="3">Here&#146;s a list of the base
        framework components and what they do:</font></p>
    </blockquote>
    <blockquote>
        <ul>
            <li><font size="3"><b>Request Object<br>
                </b>The Request object provides information about
                the current Web request. It returns information
                about form variables captured on an HTML form,
                information about the server and its status, and
                access to the HTTP header to retrieve information
                such as HTTP Cookies and Authentication
                information. Some of the collections available
                are Form, QueryString, Cookies and
                ServerVariables.</font></li>
            <li><font size="3"><b>Response Object<br>
                </b>Where the Request object provides information
                about the input from the Web server, the Response
                object is responsible for creating output for the
                Web server. ASP pages interpret HTML as usual,
                but in addition the Reponse object allows
                generating output under code control. The
                Response.Write method allows writing output
                directly. You can also manipulate the HTTP
                header, set the HTTP Cookie collection and write
                entries to the IIS log.<br>
                <br>
                The following retrieves a few form variables from
                an HTML form submission and echos whether the
                user is a new visitor or repeat:</font><pre><font
size="3" face="Courier New">&lt;%
lcName=Request(&quot;Name&quot;)		'Retrieve an HTML form variable
lcAddress=Request(&quot;Address&quot;) 	

'Reading Cookies
if Request.Cookies(&quot;wwVisitor&quot;) = &quot;&quot; then
   Response.Cookies(&quot;wwVisitor&quot;) = now  ' and write
   Response.Write(&quot;New Visitor&quot;)
else
   Response.Write(&quot;Repeat Visitor&quot;)
end if 
%&gt;
</font></pre>
            </li>
        </ul>
    </blockquote>
</blockquote>

<blockquote>
    <ul>
        <li><font size="3"><b>Session/Application Objects<br>
            </b>This pair of objects provides a mechanism for
            keeping state between requests. Web applications are
            typically stateless, which means that each request
            needs to be fully self contained. The Session and
            Application objects allow keeping state between
            requests. Active Server creates these two predefined
            objects and allows adding property values to them. <br>
            <br>
            The Session object manages a user session and has
            persistence for the duration of this user&#146;s
            visit on the site. When a user hits your site a new
            session object is created and the Session.OnStart
            method is fired. From then on the session object is
            accessible for each request. You can add variables to
            the session object and reference these variables
            between requests. The session object is implemented
            via HTTP Cookies and will not work with non-Cookie
            capable browsers!<br>
            <br>
            The Application object is similar to the Session
            object except that the Application object is
            persistent for the lifetime of the
            &#145;application&#146; &#150; a specific Web server
            virtual root directory. As with the Session object
            the Application object has OnStart and OnEnd methods
            and the ability to attach properties to the
            Application object. Since the Application is a global
            and accessible from simultaneous Web requests that
            are multithreaded access to these global properties
            needs to be tightly controlled by using the
            Lock/Unlock methods to prevent simultaneous
            overwriting of values by two sessions.<b><i><br>
            </i></b><br>
            The following creates a new database connection or
            reuses an existing one based on whether a connection
            object was attached to the Session object:</font></li>
    </ul>
</blockquote>

<blockquote>
    <blockquote>
        <pre><font size="3">&lt;%
'*** Open the Connection - create a new object or reuse existing
IF IsObject(Session(&quot;goConn&quot;)) THEN
      SET Conn=Session(&quot;goConn&quot;)
ELSE
      Set Conn = Server.CreateObject(&quot;ADODB.Connection&quot;)
      Set Session(&quot;goConn&quot;)=Conn
END IF
%&gt;
</font></pre>
    </blockquote>
</blockquote>

<blockquote>
    <blockquote>
        <p><font face="Arial"><b>Database Connectivity with
        Active Data Object (ADO)</b></font></p>
        <p><font size="3">Active Server provides built-in
        database connectivity via Active Data Objects or ADO.
        This ODBC based server component (yes, it&#146;s a COM
        based engine much like VB&#146;s DAO or RDO). It provides
        the following features:</font></p>
        <ul>
            <li><font size="3"><b>Lightweight ODBC Connector<br>
                </b>Although ADO is an OLE based component that
                gets created from within an Active Server page,
                it is a very lightweight data interface that
                provides excellent performance by implementing
                only a thin layer ontop of the native ODBC
                interface. ADO shares a similar interface with
                VB&#146;s Remote Data Objects (RDO), but provides
                an even leaner interface and much better
                performance. Make no mistake about it &#150; ADO
                is fast and provides good performance to FoxPro
                data with the VFP ODBC driver.</font></li>
        </ul>
        <ul>
            <li><font size="3"><b>Implements OLE DB (ODBC 3.0)<br>
                </b>ADO works with ODBC 3.0 and the new OLE DB
                interface specification that promises to provide
                access to <i>any</i><b> </b>kind of data
                including non-structured, non-database data.</font></li>
            <li><font size="3"><b>Based on Visual Basic&#146;s
                Remote Data Object</b><br>
                ADO shares a similar interface with VB&#146;s
                Remote Data Objects (RDO), but provides an even
                leaner interface and much better performance.</font></li>
        </ul>
        <ul>
            <li><font size="3"><b>It&#146;s fast especially when
                tied to a persistent connection object!<br>
                </b>Make no mistake about it &#150; even though
                ADO uses ODBC it is fast and provides good
                performance to FoxPro data with the VFP ODBC
                driver.</font></li>
        </ul>
        <ul>
            <li><font size="3"><b>Implemented as Automation
                Object</b><br>
                An ADO connection is created by using
                CreateObject and instantiating a COM based
                Automation object. This means that you can use
                ADO from within Visual FoxPro either for testing
                or for actual data access data through ADO.</font></li>
        </ul>
        <blockquote>
            <p><font size="3">Here&#146;s an example of using ADO
            for logging custom log information logged into a
            Visual FoxPro database with one link and then
            retrieving the log with another:</font></p>
        </blockquote>
        <blockquote>
            <pre><font size="3">'*** ODBCLOG.ASP
'*** Logging page - this page logs visitor info into
'    a VFP table via ADO
&lt;%
'*** If visitor doesn't have a cookie log the hit as a new visitor
if Request.Cookies(&quot;wwVisitor&quot;) = &quot;&quot; then
   '*** First time hit - create a cookie for the user
   Response.Cookies(&quot;wwVisitor&quot;)=now

   '*** Open the connection to the RASLOG ODBC database
   Set Conn = Server.CreateObject(&quot;ADODB.Connection&quot;)
   Conn.Open(&quot;dsn=RasLog&quot;)
   sql=&quot;INSERT INTO wwPageLog (Page, TimeStamp, Browser, Referer, IP, Other)&quot; 
   sql=sql + &quot;VALUES ('Default.asp',&quot;

   sql=sql + &quot;datetime(),&quot;
   sql=sql + &quot;'&quot; &amp; Request.ServerVariables(&quot;HTTP_USER_AGENT&quot;) &amp; &quot;',&quot;
   sql=sql + &quot;'&quot; &amp; Request.ServerVariables(&quot;HTTP_REFERER&quot;) &amp; &quot;',&quot; 
   sql=sql + &quot;'&quot; &amp; Request.ServerVariables(&quot;REMOTE_HOST&quot;) &amp; &quot;',&quot;
   sql=sql + &quot;'&quot; &amp; Request.Cookies(&quot;wwVisitor&quot;) &amp; &quot;')&quot;
  
   ' Response.Write(sql) ' debug

   Conn.Execute(sql)
   Conn.Close
   SET Conn = nothing
end if
%&gt;

&lt;html&gt;

&lt;head&gt;
&lt;title&gt;Logging&lt;/title&gt;
&lt;/head&gt;

&lt;body bgcolor=&quot;#FFFFFF&quot;&gt;
&lt;h1&gt;This could be your custom logged homepage&lt;/h1&gt;
&lt;hr&gt;
This request has been logged into a VFP database using the ADO ODBC connector. 
To view the list of recent requests click on one of the links below:
&lt;UL&gt;
&lt;li&gt;&lt;a href=&quot;ShowOdbcLog.asp&quot;&gt;Show hits on this page...&lt;/a&gt;
&lt;/UL&gt;
&lt;/body&gt;
&lt;/html&gt;


'*** ShowODBCLog.ASP - Display the results from the log
&lt;%
   '*** This code always loads the table with the log

   '*** Open the Connection
   Set Conn = Server.CreateObject(&quot;ADODB.Connection&quot;)

   Conn.Open(&quot;dsn=RasLog&quot;)
                                 
   '*** Retrieve the date from the Input form
   lcDate=Request(&quot;LogDate&quot;)
   
   '*** Handle ALL selection
   IF UCASE(lcDate)=&quot;ALL&quot; Then
      lcWhere=&quot;&quot;
   ELSE
      '*** If Emtpy default to today's date
      IF lcDate=&quot;&quot; THEN
        '*** On Empty date show all entries
	    lcDate=cDate(Date)
        lcWhere= &quot;WHERE ttod(timestamp) = ctod('&quot; &amp; lcDate &amp; &quot;')&quot; 
       ELSE
		  '*** Otherwise filter to today's date
		  lcWhere=&quot;WHERE ttod(timestamp) = ctod('&quot; &amp; Request(&quot;LogDate&quot;) &amp; &quot;')&quot; 
   
	   END IF
	END IF

   '*** Build the SQL Statement And Execute into a RecordSet
   SQL = &quot;SELECT TimeStamp, Referer, Browser, IP FROM wwPageLog &quot; &amp; _
  		 lcWhere &amp; &quot; GROUP BY 1 ORDER BY 1 DESCENDING&quot;
   
   Set rs = Conn.Execute(sql)
%&gt;
&lt;!DOCTYPE HTML PUBLIC &quot;-//IETF//DTD HTML//EN&quot;&gt;
&lt;html&gt;

&lt;head&gt;
&lt;title&gt;Show Hits to Default Page&lt;/title&gt;
&lt;/head&gt;

&lt;body bgcolor=&quot;#FFFFFF&quot;&gt;
&lt;h2&gt;Show Hits to Default.asp&lt;/h2&gt;

&lt;form action=&quot;ShowODBCLog.asp&quot; method=&quot;POST&quot;&gt;
    &lt;p&gt;&lt;strong&gt;Date:&lt;/strong&gt; 
	&lt;input type=&quot;text&quot; size=&quot;8&quot; name=&quot;LogDate&quot; value=&quot;&lt;% =lcDate%&gt;&quot; &gt;
    &lt;p&gt;
	&lt;input type=&quot;submit&quot; name=&quot;btnSubmit&quot; value=&quot;Display Log&quot;&gt;
	&lt;/p&gt;
&lt;/form&gt;

&lt;table border=&quot;1&quot; cellpadding=&quot;3&quot; width=&quot;100%&quot; bgcolor=&quot;#EEEEEE&quot;
border=&quot;3&quot;&gt;
    &lt;tr&gt;
        &lt;td align=&quot;center&quot; bgcolor=&quot;#FFFDCA&quot;&gt;&lt;strong&gt;Time&lt;/strong&gt;&lt;/td&gt;
        &lt;td align=&quot;center&quot; bgcolor=&quot;#FFFDCA&quot;&gt;&lt;strong&gt;Referer&lt;/strong&gt;&lt;/td&gt;
        &lt;td align=&quot;center&quot; bgcolor=&quot;#FFFDCA&quot;&gt;&lt;strong&gt;Browser&lt;/strong&gt;&lt;/td&gt;
        &lt;td align=&quot;center&quot; bgcolor=&quot;#FFFDCA&quot;&gt;&lt;strong&gt;IP Address&lt;/strong&gt;&lt;/td&gt;
    &lt;/tr&gt;

&lt;% Do While Not RS.EOF  %&gt;    &lt;tr&gt;
        &lt;td&gt;&lt;% =rs(&quot;Timestamp&quot;)%&gt;&lt;/td&gt;
        &lt;td&gt;&lt;a href=&quot;&lt;% =rs(&quot;Referer&quot;)%&gt;&quot;&gt;&lt;% =rs(&quot;Referer&quot;)%&gt;&lt;/a&gt;&lt;/td&gt;
        &lt;td&gt;&lt;% =rs(&quot;Browser&quot;)%&gt;&lt;/td&gt;
        &lt;td&gt;&lt;% =rs(&quot;IP&quot;)%&gt;&lt;/td&gt;
    &lt;/tr&gt;
&lt;%
RS.MoveNext
Loop

'*** Now Calc the total
sql=&quot;SELECT COUNT(*) as TotalHits FROM wwPageLog &quot;  &amp; lcWhere
SET rs=Conn.Execute(Sql)
%&gt;    &lt;tr&gt;
        &lt;td align=&quot;center&quot; colspan=&quot;3&quot; bgcolor=&quot;#FFFDCA&quot;
        align=&quot;RIGHT&quot;&gt;&lt;b&gt;Total number of hits:&lt;/b&gt;&lt;/td&gt;
        &lt;td align=&quot;center&quot; bgcolor=&quot;#FFFDCA&quot;&gt;&lt;b&gt;&lt;% =rs(&quot;TotalHits&quot;)%&gt;&lt;/b&gt;&lt;/td&gt;
    &lt;/tr&gt;
&lt;%
RS.Close
Conn.Close
%&gt;
&lt;/table&gt;
&lt;/body&gt;
&lt;/html&gt;
</font></pre>
        </blockquote>
    </blockquote>
</blockquote>

<blockquote>
    <blockquote>
        <p><font face="Arial"><b>External Object Creation with
        the Server Object</b></font></p>
        <p><font size="3">The Server object is used for server
        configuration and for the creation of Automation objects
        to extend Active Server and provide interfaces to system
        services. </font></p>
        <p><font size="3">One of the most exciting aspects of
        Active Server is it's ability to instantiate OLE
        Automation servers directly from within the HTML scripted
        code. You can use the Server.CreateObject() method to
        create an object instance to any Automation server
        available on the server machine.</font></p>
        <p><font size="3">Figure 1.4 shows how external objects
        are managed by the server. This is a crucial piece for
        interfacing Visual FoxPro code into Active Server by
        allowing the Server object to create and invoke Visual
        FoxPro Automation servers directly from within an ASP
        script.<br>
        </font></p>
        <p><font size="3"><img src="aspole.gif" width="800"
        height="600"></font></p>
        <p><font size="3"><i>Figure 1.4 - The ActiveX Server
        framework allows creation of OLE objects from within
        VBScript. Once created the object can be accessed using
        Automation server methods and properties the results of
        which can be displayed in the HTML script page.</i></font></p>
        <p><font size="1" face="Courier New"><br>
        </font><font size="3">The following Active Server page
        calls a VFP Automation server that implements a counter
        variable that&#146;s increased on each hit. The
        IncCounter() method uses VFP code to access and write the
        registry with the updated counter value. The CustList()
        method accesses a Visual FoxPro table and generates an
        HTML table that shows the contents of the table which is
        returned to the ASP page as a text string result.</font></p>
    </blockquote>
    <blockquote>
        <blockquote>
            <pre><font size="3">&lt;html&gt;
&lt;head&gt;
&lt;title&gt;Active Server Automation&lt;/title&gt;
&lt;/head&gt;

&lt;body bgcolor=&quot;#FFFFFF&quot;&gt;

&lt;h2&gt;Visual FoxPro Automation Server called from an Active Server Page&lt;/h2&gt;

&lt;hr&gt;

&lt;p&gt;This page has been hit:&lt;strong&gt; &lt;% 
   SET oServer = Server.CreateObject(&quot;wwWebtools.AspTools&quot;) 

   Response.Write(oServer.IncCounter(&quot;ASPDemoCounter&quot;))

   lcCompany=Request(&quot;txtCompany&quot;)
   %&gt; &lt;/strong&gt;times.&lt;/p&gt;

&lt;p&gt;The following table was generated by Visual FoxPro: &lt;/p&gt;

&lt;form method=&quot;POST&quot;&gt;
    &lt;p&gt;Enter a Name: &lt;input type=&quot;text&quot; size=&quot;24&quot;
    name=&quot;txtCompany&quot; value=&quot;&lt;% =lcCompany%&gt;&quot;&gt; &lt;input
    type=&quot;submit&quot; name=&quot;btnSubmit&quot; value=&quot;Filter List&quot;&gt;&lt;/p&gt;
&lt;/form&gt;

&lt;p align=&quot;center&quot;&gt;&lt;% =oServer.CustList( (lcCompany) )%&gt;&lt;/p&gt;

&lt;/body&gt;
&lt;/html&gt;
</font></pre>
        </blockquote>
    </blockquote>
    <blockquote>
        <p><font size="3">This code is very straight forward.
        However, in order to really optimize access to Automation
        servers it&#146;s crucial to persist servers across
        requests. Without this loadtime for the server is
        excessive and makes use of Automation servers
        inappropriate. To persist a server you can use the ASP
        Session object. </font></p>
        <p><font size="3">Replace the CreateObject code above
        with:</font></p>
        <blockquote>
            <pre><font size="3">IF IsObject(Session(&quot;soServer&quot;)) THEN
   SET oServer = Session(&quot;oServer&quot;)
ELSE
   SET oServer = Server.CreateObject(&quot;wwWebtools.AspTools&quot;) 
   SET Session(&quot;oServer&quot;)= oServer
END IF</font></pre>
        </blockquote>
        <p><font size="3">The server reference is now active for
        the duration of the user&#146;s session and access speed
        to the server is drastically improved.</font></p>
        <p><font face="Arial"><b>Automation Server limitations</b></font></p>
        <p><font size="3">Be aware of some serious implications
        of Automation servers that are used with ASP. Active
        Server wants to work with DLL based Automation objects,
        but Visual FoxPro will allow you to only use one DLL
        based server per Web server as VFP only supports a single
        copy of the runtime in memory of any single process (in
        this case the Web server). The single copy can only
        serialize calls to itself, so if you run a long query any
        other hits on that same server are blocked.<br>
        </font></p>
        <p><font size="3">By default ASP doesn't even run with
        EXE servers &#150; you need to set a registry value (look
        in the Active Server Roadmap under Registry settings
        under AllowOutofProcessObjects). You can multiple EXE
        servers at the same time, but be aware that any EXE based
        OLE server <i>calls will block all other EXE Automation
        calls at the same time</i>! This has some serious
        implications on performance as everything is bottled down
        to a single thread while your server executes. Hence,
        it's not recommended that you use Automation servers for
        any operations that are lengthy.</font></p>
        <p><font face="Arial"><b>Active Server Summary</b></font></p>
        <p><font color="#FF0000" face="Arial"><b>Pros:</b></font></p>
    </blockquote>
</blockquote>

<blockquote>
    <blockquote>
        <ul>
            <li><font size="3"><b>Tight Integration with IIS<br>
                </b>Because Active Server is tightly integrated
                into IIS it provides excellent performance
                that&#146;s tuned to the Web server and its
                multithreaded environment. Thread management and
                ODBC connection pooling is managed for you to an
                extent.</font></li>
            <li><font size="3"><b>No hassle configuration<br>
                </b>Since the code and HTML both reside in the
                same document, setup for building an Active page
                is minimal. If data acess is required only a ODBC
                connection needs to be configured and you&#146;re
                off and running.</font></li>
            <li><font size="3"><b>Very easy for simple active
                content<br>
                </b>Scripting in HTML is straightforward and
                VBScript is reasonably powerful to do the basics
                language handling. ADO provides data quick access
                with a minimal object model that can be picked up
                fairly quickly.</font></li>
            <li><font size="3"><b>Extensible with Automation
                objects</b></font></li>
            <li><font size="3"><b>Think of Active Server as the
                HTML driving the application</b></font></li>
        </ul>
        <p><font color="#FF0000" face="Arial"><b>Cons:</b></font></p>
        <ul>
            <li><font size="3"><b>Code Management<br>
                </b>Building complex logic inside of HTML pages
                can be tedious even when using a tool like Visual
                InterDev. Trying to dig through a long HTML
                document and finding code inside of it is no fun.
                Structured coding also goes out the window in
                many cases as code follows the HTML output more
                than it necessarily follows the program logic.</font></li>
            <li><font size="3"><b>Limited Development Environment</b><br>
                Although Visual InterDev provides a rich shell
                and a number of very useful Wizards for building
                Active Server Pages, development support for
                coding and debugging is very primitive.
                There&#146;s no way to step through code and see
                variable values in the development environment
                for example. Error handling support in VBScript
                is a far cry from sophisticated where errors
                cannot be delegated but must be fully anticipated
                and managed at the time of error. The alternative
                is an ugly VBScript or ODBC runtime error
                message.</font></li>
            <li><font size="3"><b>Automation Server Scalability<br>
                </b>ASP&#146;s ability to call external
                Automation servers is extremely powerful.
                Unfortunately, when calling Visual FoxPro servers
                calls to any single VFP server are serialized
                since VFP can only load one instance of a
                particular server at a time and process that
                request on its single application thread. True
                multi-threading of Automation servers is
                supported currently only from pure COM based
                servers that are built in low level languages
                like C++ or Delphi.<br>
                <br>
                What this means is that if your Web server gets
                busy enough to require more than one instance of
                your Automation server you will have no way to
                scale up. You can rearrange your servers to break
                up the request load on each server by splitting
                into smaller servers, but even that might not be
                sufficient.</font></li>
            <li><font size="3"><b>Scripting Language Limitations<br>
                </b>For building full featured applications the
                VBScript language is fairly limited. VBScript is
                a subset of VB for Applications and misses a
                number of that VB subset&#146;s features.
                There&#146;s no access to the WinAPI or even to
                VB&#146;s file handling functions &#150; for many
                features that are commonly required in any
                programming language you&#146;ll be required to
                call Automation objects to help out. With the
                overhead involved this might not always be a good
                option.</font></li>
            <li><font size="3"><b>ODBC Data Management<br>
                </b>Data access via ADO to VFP tables is
                straightforward and speed is acceptable. However,
                if you need to handle maintainence tasks to your
                data that require Exclusive database access
                it&#146;s next to impossible to implement these
                via a Web based interface. Since ODBC keeps
                tables open and multiple requests might hit your
                pages simultaneously it&#146;s unlikely you can
                ever get an Exclusive lock on a table to say
                clear a file (log files can get big) or even do
                things as simple as APPENing data from an
                external file. True Exclusive access to VFP data
                requires shutting down the Web server and running
                a VFP program against the data.</font></li>
        </ul>
    </blockquote>
</blockquote>

<p><a name="FOXISAPI"><font color="#800040" size="5" face="Arial"><b>FoxISAPI</b></font></a></p>

<blockquote>
    <blockquote>
        <p><font size="3">Visual FoxPro's new capability to
        create OLE servers has brought about another slick option
        for implementing Visual FoxPro based Web applications.
        What if you could use an OLE server to respond to a
        request placed from a Web page to handle the data
        processing and HTML page generation? With a cool called
        FoxISAPI that's provided by Microsoft with Visual FoxPro
        you can do just that.</font></p>
        <p><font size="3"><img src="foxisapi.gif" width="800"
        height="600"></font></p>
        <blockquote>
            <p><font size="3"><i>Figure 1.5 - FoxISAPI uses an
            ISAPI DLL to create an instance of an OLE server and
            call the specified method in the server.</i></font></p>
        </blockquote>
        <p><font face="Arial"><b>Connect VFP OLE servers to HTML
        HREF or form links</b></font></p>
        <p><font size="3">FoxISAPI is used by calling the
        FoxISAPI.dll from an HTML link or form. A typical HTML
        link looks like this:</font></p>
        <p><font size="2" face="Courier New"><b>HREF=&quot;/scripts/foxisapi.dll/Tserver.Tclass.Tmethod?UID=1111&amp;Name=Rick&quot;</b></font></p>
        <p><font face="Arial"><b>ISAPI DLL instantiates
        persistent OLE Automation object</b></font></p>
        <p><font size="3">FoxISAPI works by calling an ISAPI
        script from an HTML HREF or form link. The FoxISAPI.dll
        creates an object reference to the object passed as part
        of the URL and calls the specified method. The object is
        persistent so repeated access to the object is very quick
        as the object is never reloaded unless explicitly
        unloaded (more on that below).</font></p>
        <p><font size="3">In the example above FoxISAPI parses
        out the ClassId and method call to instantiate the
        Tserver.Tclass OLE server (equivalent to doing </font><font
        size="2" face="Courier New"><b>CREATEOBJ(&quot;Tserver.Tclass&quot;)</b></font><font
        size="2"><b> </b></font><font size="3">in VFP) and then
        goes ahead and calls the Tmethod() method (equivalent to </font><font
        size="2" face="Courier New"><b>lcResult =
        oServer.Tmethod(cParm1,cParm2,nParm3)</b></font><font
        size="3">). FoxISAPI expects your method to return an
        HTTP compliant result string - in most cases this result
        will be an HTML document, but could also be an HTTP
        request for Authentication or Redirection.</font></p>
        <p><font face="Arial"><b>Passes form variables as
        parameter and server variables in an INI file</b></font></p>
        <p><font size="3">When FoxISAPI calls your OLE server it
        passes along 3 parameters to each request method that is
        called. Your server method that respond directly to
        request must support these three parameters:</font></p>
    </blockquote>
    <blockquote>
        <ul>
            <li><b>lcFormVar </b><br>
                The first parameter contains any 'parameters'
                passed on the Query string as described in the
                example above or any form variables retrieved
                from an HTML form via an HTTP GET or POST.<br>
                <br>
                The format of the parameter string contains a
                key/value pair for each of the form variables or
                'parameters' passed. The keys in the above
                example are UID and Name the values are 1111 and
                Rick. These key value pairs are what is known as
                URL encoded, which means they follow a specific
                protocol of encoding to allow passing special
                characters on the URL or via form variables. It
                works something like this:</li>
        </ul>
    </blockquote>
    <blockquote>
        <blockquote>
            <ul>
                <li>Key value pairs are separated by <b>&amp;.</b></li>
                <li>Spaces are converted to <b>+</b>.</li>
                <li>All 'extended' characters are converted to
                    Hex escape codes. The escape code uses a
                    percent sign plus a hex number to store the
                    ASCII code of the characters. For example a
                    carriage return (ASC(13)) is encoded as <b>%0D.</b></li>
                <li>The EMPLOYEE example in your
                    \VFP\SAMPLES\SERVERS\FOXISAPI directory
                    includes a decoding algorithm as does the
                    starter FoxISAPI class provided on the DevCon
                    CD (FoxISAPI::DecodeURL).</li>
                <li><b>lcIniFile</b><br>
                    This parameter contains the path to an INI
                    file that contains all the server, browser
                    and system variables. You can retrieve these
                    with calls to the GetProfileString API call
                    (or use the CDs
                    FoxISAPI::GetCGIVar(cVarname,cSection)).</li>
                <li><b>lnReleaseFlag<br>
                    </b>This parameter determines whether the
                    reference to the OLE server will be kept or
                    released. By default it's a good idea to keep
                    the reference to keep a connection in order
                    to minimize load time of the server. The
                    parameter is passed in by reference so
                    changing it in your code will effectively<br>
                    <b>0 -</b> Keep Server Reference <i>(default)</i><br>
                    <b>1 -</b> Release Server Reference</li>
            </ul>
        </blockquote>
    </blockquote>
    <blockquote>
        <p><font face="Arial"><b>Must return HTTP compliant
        output</b></font></p>
        <p><font size="3">Once your code gets control you can use
        VFP as you see fit to run queries or run any other kind
        of transaction or logic operation using FoxPro code. The
        end result of each exit point of your method must be a
        HTTP compliant string.</font></p>
        <p><font size="3">In most cases the output will be an
        HTML document, but you have to be sure to add an HTTP
        header to the top of it. Output should look like this:</font></p>
        <pre>HTTP/1.0 200 OK
Content-type: text/html

&lt;HTML&gt;
&lt;H1&gt;Hello World&lt;/H2&gt;
&lt;/HTML&gt;</pre>
        <p><font size="3">The HTTP header and Content-type are
        important since not all browsers will support headerless
        results. Note each line of the header must be separated
        by a CHR(13)+CHR(10) and the final header line must be
        followed by a blank line containing only the
        CHR(13)+CHR(10).</font></p>
        <p><font face="Arial"><b>HTTP headers for authentication,
        redirection, Cookies etc.</b></font></p>
        <p><font size="3">While you will almost always return an
        HTML document it's possible to generate standard HTTP
        header responses as well. For example, if you wanted to
        cause Authentication to occur you might pass:</font></p>
        <pre>HTTP/1.0 401 Not Authorized
WWW-Authenticate: basic realm=west-wind.com

&lt;HTML&gt;
Get out and stay out!!!
&lt;/HTML&gt;</pre>
        <p><font size="3">This would cause an authentication box
        to be thrown up by the browser. You can then check the
        password entered as passed back in a the Authenticated
        User CGI variable to determine whether to allow the user
        in (actually NT will first fail the user if the user is
        not valid as per the User Manager).</font></p>
        <p><font face="Arial"><b>A simple FoxISAPI Server code
        example</b></font></p>
        <p><font size="3">The following code snippet shows the
        simplest OLE server you can build and run with FoxISAPI.
        While this is not a very functional example it does show
        the basic elements required when building methods for
        responding to FoxISAPI calls.</font></p>
        <p><font size="3">The script would be called with the
        following URL HREF link:</font></p>
        <pre><b>
   </b><font size="3"><b>HREF=&quot;/scripts/foxisapi.dll/TDevCon.TFoxIsapi.Helloworld?&quot;</b></font></pre>
        <p>&nbsp;</p>
        <p><font size="3">You'd create an OLE server named
        TDevCon with the following code:</font></p>
        <pre>
#DEFINE CR CHR(13)+CHR(10)

DEFINE CLASS TFoxISAPI AS Custom OLEPUBLIC

FUNCTION Helloworld
LPARAMETER lcFormVars, lcIniFile, lnReleaseFlag
LOCAL lcOutput

*** HTTP header - REQUIRED on each request!
*** System Defines
lcOutput=&quot;HTTP/1.0 200 OK&quot;+CR+;
         &quot;Content-type: text/html&quot;+CR+CR

lcOutput=lcOutput+;
   &quot;&lt;HTML&gt;&lt;BODY&gt;&quot;+CR+;
   &quot;&lt;H1&gt;Hello World from Visual FoxPro&lt;/H1&gt;&lt;HR&gt;&quot;+CR+;
   &quot;This page was generated by Visual FoxPro...&lt;HR&gt;&quot;+CR+;
   &quot;&lt;/HTML&gt;&lt;/BODY&gt;&quot;

RETURN lcOutput

ENDDEFINE</pre>
        <p><font size="3">Note that the HTTP header is created as
        part of the output and that the output, header and HTML
        document both, are returned by the function. FoxISAPI
        takes this output and sends it - as is - back to the Web
        browser.</font></p>
        <p><font face="Arial"><b>Set up for OLE Servers called by
        Web services</b></font></p>
        <p><font size="3">Setting up FoxISAPI is the most tricky
        part of working with this tool. Especially when running
        under Windows NT 4.0 special steps have to be taken to
        make sure OLE servers can be properly created by the Web
        server process which owns the FoxISAPI process that calls
        your OLE servers. BTW, the same rules apply to OLE
        servers called by Denali!</font></p>
        <p><font face="Arial"><b>OLE Server must be registered</b></font></p>
        <p><font size="3">The first step is to make sure your OLE
        server is registered on the Web server machine. If you
        build your project on the same box then the server is
        already registered for you when VFP built the project. </font></p>
        <p><font size="3">If you're only copying the OLE server
        to this machine make sure you run:</font></p>
    </blockquote>
</blockquote>

<blockquote>
    <blockquote>
        <ul>
            <li><b>EXE Server</b><br>
                MyServer.exe /regserver</li>
            <li><b>DLL Server</b><br>
                \winnt\system32\regsvr32.exe Myserver.dll</li>
        </ul>
    </blockquote>
</blockquote>

<p>&nbsp;</p>

<blockquote>
    <blockquote>
        <blockquote>
            <p>to register the server in the Web server's
            registry.</p>
        </blockquote>
        <p><font face="Arial"><b>Copy FoxISAPI.dll into script
        dir</b></font></p>
    </blockquote>
    <blockquote>
        <ul>
            <li>Default server script dir is <b>c:\inetsvr\wwwroot\scripts/scripts
                &#150; </b>typically it&#146;s mapped just off
                the Web root: </li>
            <li>If you create a new directory you must map it and
                set Web Server Execute rights to allow executing
                the ISAPI dll.</li>
        </ul>
    </blockquote>
    <blockquote>
        <p><font face="Arial"><b>Run DCOMCnfg on NT 4.0</b></font></p>
        <p><font size="3">On Windows NT 4.0 DCOM configuration is
        necessary for all EXE servers launched by the Web server
        process. DLL servers also need to have at least the
        default rights set to include the Web server user account
        with launch permissions.</font></p>
    </blockquote>
    <blockquote>
        <p><b>Add IUSR_ account to default rights<br>
        </b>The IUSER_Machine account is the user account used by
        IIS while running a Web request. This account needs to be
        added to provide default launch and access rights for all
        OLE servers:</p>
        <p>Start DCOMCNFG</p>
        <p>Go to Default Security</p>
        <p>Add IUSR_ to Default Access Permissions</p>
        <p><b>Set user to Interactive User on the specific server<br>
        </b>EXE require that the server is defined for
        interactive use. To set this:</p>
        <ol>
            <li>Go to the Applications Tab</li>
            <li>Select the Class (TFoxIsapi in the example)</li>
            <li>Click Properties</li>
            <li>Go to the Identity tab</li>
            <li>Click The Interactive User</li>
            <li>Click Apply</li>
        </ol>
        <p><b>Re-run whenever server is rebuilt</b><br>
        Repeat steps 4 - 10 whenever rebuilding the server on the
        local machine, which rebuilds the OLE Ids and blows away
        the DCOM settings.</p>
    </blockquote>
    <blockquote>
        <p><font face="Arial"><b>FoxISAPI OLE Instancing</b></font></p>
        <p><font size="3">As with all OLE servers instancing can
        have a big effect on how your application performs. For
        Web applications instancing is even more important a
        speed is crucial and multiple simultaneous requests need
        to be processed.</font></p>
        <p><font face="Arial"><b>InProcess DLL</b></font></p>
    </blockquote>
    <blockquote>
        <ul>
            <li><b>Very fast</b></li>
            <li><b>Requests are queued</b></li>
            <li><b>Only 1 VFP server can be InProcess</b><br>
                OLE servers share the VFP runtime DLL and only
                one instance of this DLL is allowed at any one
                time in the same process.</li>
            <li><b>DLLs cannot be unloaded except by shutting the
                Web server down.</b></li>
        </ul>
    </blockquote>
    <blockquote>
        <p><font face="Arial"><b>MultiUse (Out of Process)</b></font></p>
    </blockquote>
    <blockquote>
        <ul>
            <li><b>Slightly slower</b></li>
            <li><b>Requests are queued</b></li>
            <li><b>Multiple </b><b><i>different</i></b><b>
                servers<br>
                </b>One renamed FoxISAPI.DLL for each OLE server
                would allow requests to be processed
                simultaneously, but only for different OLE
                servers.</li>
        </ul>
    </blockquote>
    <blockquote>
        <p><font face="Arial"><b>FoxISAPI.dll can only call one
        Automation server at a time</b></font></p>
        <p><font size="3">Although ISAPI dll's are
        multi-threaded, FoxISAPI cannot directly take advantage
        of this multi-threading. This was done to prevent OLE
        access errors that are called by overlapping calls to the
        same OLE servers using the same ID.</font></p>
        <p><font size="3">FoxISAPI essentially blocks any further
        OLE calls while a method call is already in process. What
        this means is that in essence FoxISAPI is limited to
        queing requests.</font></p>
        <p><font size="3">There's a way around this, at least for
        calling different OLE servers simultaneously by
        essentially attaching each OLE server to its own ISAPI
        dll. That way calls to the same server are always blocked
        as required, but other servers can be freely called to
        execute.</font></p>
        <p><font face="Arial"><b>Same OLE server cannot execute
        more than 1 instance at the same time</b></font></p>
        <p><font size="3">Even with the above work-around I have
        not found a way to call the same server and create two
        simultaneous instances, which is fairly important on busy
        sites. As it stands the only way to scale OLE servers is
        by breaking down the application into many smaller OLE
        servers so that the request load gets balanced between
        servers.</font></p>
        <p><font size="3">On the other hand, the simultaneous
        access issue might not be so important if your site can
        generate all output in short time frames. If request
        responses are subsecond and your request load does not
        exceed the timeouts a single session can go a long way
        before hitting the wall. I've been running somewhere
        around 80,000 hits on a Commerce site before a second
        session was required. But request times were an average
        of .12 seconds.</font></p>
        <p><font size="3">However, if you have many requests that
        are lengthy, multiple sessions become crucial to allow
        the site to remain responsive while the lengthy request
        continues processing in the background.</font></p>
        <p><font face="Arial"><b>Starter FoxISAPI class provided
        on the CD</b></font></p>
        <p><font size="3">The DevCON CD contains a starter
        FoxISAPI class that contains a few useful methods for
        handling typical tasks when handling FoxISAPI requests.
        This class is by no means extensive, nor does it provide
        all the features you need, but it's a starting point for
        writing your own library. For a more complete
        implementation framework of class you might want to check
        out Web Connection's OLE connector library.</font></p>
        <p><font size="3">Following is a list of methods and
        properties available in the FoxISAPI class:</font></p>
        <pre><b>cOutput			Temporary holding property that contains all
			text output to be returned from the request
			Method
Send/SendLn()		Send  text to output
StandardPage()		Generates a full HTML page
ContentTypeHeader()	Adds HTTP header 
StartRequest()		Called to set up a request. Decodes input vars 
                        and clears the cOutput property.
GetFormVar()		Retrieves a form variable passed in 				           	                       with the first parameter.
GetCGIVar()		Retrieves a server/browser Variable from 
                        the INI file.
ReleaseServer()		Standard method that releases OLE server.</b></pre>
        <p><font size="3">Here's another complete, simple example
        server that uses most of the above methods (note this
        method should be in the same class as the example
        described above &#150; the class header is provided here
        for completeness of the sample only):</font></p>
        <pre><b>
</b>DEFINE CLASS TFoxISAPI AS FoxISAPI OLEPUBLIC

FUNCTION TestMethod
LPARAMETER lcFormVars, lcIniFile, lnReleaseFlag
LOCAL lcOutput

*** Decode the Form Vars and assign INI file to class property
THIS.StartRequest(lcFormVars,lcIniFile)

*** Don't Release the server 
* lnReleaseFlag=0       &amp;&amp; 0 - Don't release (default)  1 - Release

*** Must always add a content Type Header
THIS.HTMLContentTypeHeader()

*** Grab HTML Form Variables
lcUserId=THIS.GetFormVar(&quot;UserId&quot;)
lcName=THIS.GetFormVar(&quot;UserName&quot;)

*** Start HTML Generation
THIS.SendLn(&quot;&lt;HTML&gt;&lt;HEAD&gt;&lt;TITLE&gt;Hello from FoxISAPI&lt;/TITLE&gt;&lt;HEAD&gt;&lt;BODY&gt;&quot;)
THIS.SendLn(&quot;&lt;H1&gt;&lt;FONT=Arial COLOR=#800000&gt;Hello World from Visual FoxPro&lt;/FONT&gt;&lt;/H1&gt;&quot;)
*THIS.SendLn(&quot;This page was generated by Visual FoxPro using FOXISAPI. &quot;)
*THIS.SendLn(&quot;The current time is: &quot;+time()+&quot;&lt;p&gt;&quot;)

THIS.SendLn(&quot;&lt;b&gt;Encoded Form/URL variables:&lt;/b&gt; &quot;+lcFormVars+&quot;&lt;BR&gt;&quot;)
THIS.SendLn(&quot;&lt;b&gt;Decoded UserId:&lt;/b&gt; &quot;+ THIS.GetFormVar(&quot;UserId&quot;)+&quot;&lt;br&gt;&quot;)
THIS.SendLn(&quot;&lt;b&gt;Decoded UserName:&lt;/b&gt; &quot; +THIS.GetFormVar(&quot;UserName&quot;)+&quot;&lt;P&gt;&quot;)

*** Show the content of the FOXISAPI INI server/browser vars
IF !EMPTY(lcIniFile) AND FILE(lcIniFile)
   CREATE CURSOR TMemo (TFile M )
   APPEND BLANK
   APPEND MEMO TFile from (lcIniFile)
   THIS.SendLn(&quot;Here's the content of: &lt;i&gt;&quot;+lcIniFile+;
     &quot;&lt;/i&gt;. You can retrieve any of these with &lt;i&gt;THIS.GetCGIVar(cVarname,cSection)&lt;/i&gt;:&lt;p&gt;&quot;)
   THIS.SendLn([THIS.GetCGIVar(&quot;HTTP_USER_AGENT&quot;,&quot;ALL_HTTP&quot;): ]+;
                THIS.GetCGIVar(&quot;HTTP_USER_AGENT&quot;,&quot;ALL_HTTP&quot;))
  
   THIS.Send(&quot;&lt;PRE&gt;&quot;)
   THIS.SendLn(Tmemo.Tfile)
   THIS.SendLn(&quot;&lt;/PRE&gt;&quot;)
   USE in TMemo
ENDIF

THIS.SendLn(&quot;&lt;HR&gt;&lt;/HTML&gt;&lt;/BODY&gt;&quot;)

RETURN THIS.cOutput

ENDDEFINE</pre>
        <p><font color="#000000" face="Arial"><b>FoxISAPI Summary</b></font></p>
        <p><font color="#FF0000" face="Arial"><b>Pros:</b></font></p>
    </blockquote>
</blockquote>

<blockquote>
    <blockquote>
        <ul>
            <li><font size="3"><b>Full support for Visual FoxPro<br>
                </b>You can take advantage of your existing
                Visual FoxPro skills to build Web logic in record
                time. Visual FoxPro&#146;s data centric and
                object oriented language is uniquely geared
                toward building data centric applications that
                are typical of the Web&#146;s transaction based
                processing of database data.</font></li>
        </ul>
        <ul>
            <li><font size="3"><b>Real Development Environment<br>
                </b>By using Visual FoxPro you have access to the
                full development environment using the editor
                debugger and all of your existing Visual FoxPro
                tools to build and generate code quickly.</font></li>
            <li><font size="3"><b>Excellent performance<br>
                </b>The Visual FoxPro data engine is still the
                fastest way to access data by a huge margin.
                Unless the amount data in question is gigantic
                VFP will outperform even SQL servers by a wide
                margin in most cases. </font></li>
        </ul>
        <p><font color="#FF0000" face="Arial"><b>Cons:</b></font></p>
    </blockquote>
</blockquote>

<blockquote>
    <blockquote>
        <ul>
            <li><font size="3"><b>Difficult First Time
                Configuration</b><br>
                Setup for Automation servers is a little tricky
                with the requirement to set permission on the
                Automation objects and making sure that data and
                HTML paths are set up correctly. Since VFP
                handles the underlying logic it needs to know
                where all the various pieces are located
                explicitly via hardcoded paths (including a
                &#145;startup directory&#146;).</font></li>
            <li><font size="3"><b>No Web specific code support<br>
                </b>FoxISAPI provides little in the way of HTML
                generation or request parsing routines. The
                sample applet and this FoxISAPI class presented
                here provide the basics, but it&#146;s limited.</font></li>
            <li><font size="3"><b>No Interactive Debugging
                support<br>
                </b>FoxISAPI does not support interactive
                debugging of Web requests. You can simulate Web
                requests by creating requests with the
                appropriate FormVars passed via string and
                creating dummy INI files with server variables,
                but you can&#146;t debug a live server.</font></li>
            <li><font size="3"><b>Doesn&#146;t run on non-ISAPI
                servers or Windows &#146;95<br>
                </b>FoxISAPI requires an ISAPI compliant Web
                server. Currently FoxISAPI does not run reliably
                on Windows &#146;95. This might change with the
                release of DCOM for Windows &#145;95.</font></li>
        </ul>
    </blockquote>
</blockquote>

<blockquote>
    <p><a name="WEBCONNECTION"><font color="#800040" size="5"
    face="Arial"><b>West Wind Web Connection </b></font></a></p>
    <blockquote>
        <p><font size="3">FoxISAPI provides basic Web
        connectivity features that are relatively easy to build
        using Visual FoxPro as a back end server. Web Connection
        expands on the basic functionality of FoxISAPI by
        providing an entire application framework and set of
        tools that make it easy to build Web based backend
        applications in Visual FoxPro. </font></p>
        <p><font face="Arial"><b>Extensive Visual FoxPro
        framework for Web development</b></font></p>
        <p><font size="3">Web Connection provides host of
        functionality that is specific to Web development. The
        Web Connection framework provides a number of predefined
        objects that greatly simplify the process of Web
        application development by abstracting all the Web
        specific logic into class libraries so you can focus on
        your application and not on how to get and output
        information to and from the Web server. </font></p>
        <p><font size="3">Applications are built in an
        application class that has built-in objects for
        retrieving server and HTML form variables from the Web
        server and an extremely powerful and flexible HTML class
        that allows for on the fly HTML HTML</font></p>
        <p><font size="3">Creation using both low level and high
        level methods. For example, you can display data with a
        single call to the ShowCursor() and output the current
        table to HTML. HTML based scripting with Visual FoxPro
        code is available via the ShowHTMLFile() method which
        allows embedding of Visual FoxPro expressions and even
        entire code blocks directly into the HTML to be
        displayed. Or if you need low level control you can use
        the Send() method to output text directly to the server.
        The HTML class contains over 50 methods for helping you
        create HTML quickly and providing full control over the
        HTTP output including built-in support for HTTP Headers,
        Cookies, graphing via ActiveX&#133;</font></p>
        <p><font size="3">The application framework also provides
        solid error handling and reporting, parameter parsing,
        displaying HTML pages from disk via script mapping, form
        variable decoding, sending SMTP email, FTP and domain
        name lookup and much more.</font></p>
        <p><font face="Arial"><b>Simulated multi-threading with
        multiple VFP sessions</b></font></p>
        <p><font size="3">Web Connection natively supports
        running multiple instances of any Web Connection server
        either on the local machine or across the network for
        maximum scalability. Web Connection has been clocked at
        close to 200,000/day Visual FoxPro backend hits using two
        instances of Visual FoxPro Automation servers running on
        a live commerce site (</font><a
        href="http://www.surplusdirect.com/"><font size="3">http://www.surplusdirect.com/</font></a><font
        size="3">). Up to 450,000 hits have been tested in an
        offline testing environment and even that hasn&#146;t
        maxed out a single machine (Single processor Ppro 200
        with 64 megs &#150; average request time: 0.12 secs).</font></p>
        <p><font size="3">Under OLE Automation the Web Connection
        DLL manages multiple persistent instances of the same
        Automation server and services requests round robin
        optimizing throughput through servers. With file based
        messaging multiple EXE&#146;s or standalone applications
        can be started and run transparently against the same set
        of data. Scaling up with multiple server instances is
        totally transparent to the implementation!</font></p>
        <p><font size="3">Why run multiple servers? Visual FoxPro
        doesn't support multi-threading but you can simulate this
        feature by running multiple Visual FoxPro sessions each
        running a copy of the Web data server. Multiple servers
        typically don&#146;t enhance overall performance, but
        they can provide better responsiveness to the users of
        your site by making it possible to process short requests
        </font></p>
        <p><font size="3">A single processor can handle two
        sessions without much overhead, although more session
        than that will start showing drastic slowdowns as the CPU
        load gets too large with the simultaneous queries.
        Multi-processor machines allow additional sessions to
        scale closer to 90% per session throughput that is
        acceptable. </font></p>
        <p><font face="Arial"><b>Scalable across multiple
        machines over the network</b></font></p>
        <p><font size="3">Web Connection can also scale across
        the network to further expand processing power if you've
        maxed out the local processor(s). Web servers are
        multi-threaded and are fairly CPU intensive especially on
        single processor machines. Moving processing off the
        local machine to a network machine frees up the Web
        server for providing better response which is important
        for keeping sites running smoothly. </font></p>
        <p><font size="3">Keep in mind though that scaling over
        the network incurs a slight performance hit. Local disk
        access is usually much quicker than requests and result
        pages travelling over the network. Still, in combination
        with local data servers, remote servers can greatly
        enhance the Scalability of a site. </font></p>
        <p><font face="Arial"><b>Online code updates without
        shutting down Web server</b></font></p>
        <p><font size="3">Web Connection supports live code
        updates by providing an update mode for Automation
        servers that hold all requests and then update the
        Automation server EXE from an update path. Files can be
        uploaded to the server via the update path and then hot
        swapped via an HTML link. </font></p>
        <p><font face="Arial"><b>Real time, live debugging</b></font></p>
        <p><font size="3">Like FoxISAPI Web Connection leverages
        ISAPI and OLE Automation, but Web Connection also
        supports a file based &#145;interactive&#146; mode that
        can run on non-ISAPI Web servers as well as providing a
        real time &#145;live&#146; development environment inside
        an interactive Visual FoxPro session, so you can debug
        your server in real time from real Web requests.</font></p>
        <p><font size="3">You can receive a request from the Web
        server and set a breakpoint and step through the code
        when the request hits. This allows you to test in a live
        environment where you see the actual hit incoming from
        the Web server rather than depending on simulated test
        data manually passed to the server.</font></p>
        <p><font size="3">The code, compile, debug, fix code
        cycle is also much quicker since you can fix errors at
        the source when the code crashes where you can
        immediately fire up the debugger and examine the status
        of the application.</font></p>
        <p><font face="Arial"><b>Server Management</b></font></p>
        <p><font size="3">One of the strengths of Web Connection
        is that the framework is geared towards helping
        automating server addministration. Web Connection can
        automatically log each incoming Web Request and provide
        both HTML and VFP based viewers for the data. Sessions
        can be managed both via an HTML based administration page
        or via settings in an INI file for startup settings.
        It&#146;s possible to start and stop servers remotely and
        get information on which servers are running and their
        load. In addition maintaincence modes are supported so
        all but one server can be shut down to allow exclusive
        access to data.</font></p>
    </blockquote>
    <p><font size="3"><img src="wconnect.gif" width="800"
    height="600"></font></p>
    <blockquote>
        <h3><font size="4" face="Arial"><b>How Web Connection
        works</b></font></h3>
    </blockquote>
    <blockquote>
        <p><font size="3">Web Connection&#146;s approach to
        creating Web application is similar to FoxISAPI&#146;s
        although the overall implementation is a little more
        complex as the framework uses a number of interrelated
        objects to provide the additional functionality described
        above. </font></p>
        <p><font size="3">With FoxISAPI your interface to the
        FoxPro application is direct: You call a method in an
        Automation server directly. While simple this also means
        that each and every method call in FoxISAPI needs to call
        various methods/functions on each hit to provide form
        variable parsing, header creation, set up for HTML output
        etc. </font></p>
        <p><font size="3">Web Connection expands on that scheme
        by having a generic server object (which is the OLEPUBLIC
        object) take each Web hit and delegating it to the proper
        program/class. Each hit creates a new class and calls a
        pre-defined method (Process()). By doing so all the Web
        specific processing is not splattered into the
        application code but handled by the generic server
        object. You get a central entry point that allows you to
        hook logic that applies to every Web request.</font></p>
        <p><font size="3">The actual method to handle your
        request is then parsed out of the URL command line. A
        typical HREF link looks like this:</font></p>
        <p><font size="3"><b>HREF=&quot;wc.dll?MyPrg~MyMethod&quot;</b></font></p>
        <p><font size="3"><img src="wwserver.gif" width="800"
        height="600"></font></p>
        <p><font size="3"><i>Figure 1.6 - The Web Connection data
        server uses the framework classes to call a method in a
        CGIProcess object. Adding request handlers is as easy as
        adding a method to the class.</i></font></p>
        <p><font size="3">The CGIProcess object which contains
        the custom code methods creates both a CGI and HTML
        object when created and preconfigures these for immediate
        use. A typical program file that contains the logic to
        create a new process object and response method looks
        like this:</font></p>
        <pre>*** This routine creates the object and calls the Process() method
PROCEDURE MyPRG
LPARAMETER loCGI</pre>
        <pre>#INCLUDE WCONNECT.H
#DEFINE HTMLPAGEPATH &quot;h:\http\wconnect\&quot;
#DEFINE DATAPATH &quot;wwdemo\&quot;

*** Now create a process object
loCGIProcess=CREATE(&quot;webConnectDemo&quot;,loCGI)
IF TYPE(&quot;loCGIProcess&quot;)#&quot;O&quot;
   *** All we can do is return...
   WAIT WINDOW NOWAIT &quot;Unable to create CGI Processing object...&quot;
   RETURN .F.
ENDIF

*** Call the Process Method that handles the request
loCGIProcess.Process

RETURN


*** Application Class Implementation
DEFINE CLASS DevConDemo AS wwCGIProcess   &amp;&amp; Baseclass Custom

FUNCTION CustomerList
LOCAL loCGI, loHTML

*** Easier reference
loCGI=THIS.oCGI
loHTML=THIS.oHTML

*** Retrieve the name the user entered - could be blank
lcCustname=loCGI.GetFormVar(&quot;Search&quot;)
lcBrowser=loCGI.GetBrowser()    &amp;&amp; Retrieve Browser name/User Agent

*** Get all entries that have time entries (expense=.F.)
SELECT tt_cust.Company ;
   FROM TT_Cust ; 
   WHERE tt_cust.company=lcCustname ;
   ORDER BY Company ;
   INTO CURSOR TQuery

IF _TALLY &lt; 1
   *** Return an HTML response page 
   *** You can subclass ErrorMsg to create a customized 'error page'
   THIS.ErrorMsg(&quot;No Matching Records Found&quot;,;
                 &quot;Please pick another name or use fewer letters &quot;+;
                 &quot;to identify the name to look up&lt;p&gt;&lt;HR&gt;&quot;)
   RETURN
ENDIF

*** Create HTML document header
*** - Document header, a Browser title, Background Image
loHTML.HTMLHeader(&quot;Customer List&quot;,&quot;Web Connection Customer List&quot;,;
                  &quot;/wconnect/whitwav.jpg&quot;)

loHTML.SendLn(&quot;&lt;b&gt;Returned Records: &quot;+STR(_TALLY)+&quot;&lt;/b&gt;&quot;)
loHTML.SendPar()
loHTML.SendLn(&quot;&lt;CENTER&gt;&quot;)

&amp;&amp; Set Display to table or &lt;PRE&gt; list - Optional
loHTML.SetAllowHTMLTables(loCGI.IsHTML30()) 

*** Show entire result set as an HTML table
loHTML.ShowCursor()

*** Center the table
loHTML.SendLn(&quot;&lt;/CENTER&gt;&quot;)

loHTML.HTMLFooter(PAGEFOOT)

USE IN TQuery
ENDFUNC
* EOF CustomerList</pre>
    </blockquote>
</blockquote>

<pre>	    FUNCTION MyMethod2
            ...
            ENDFUNC </pre>

<pre>            ENDDEFINE </pre>

<blockquote>
    <blockquote>
        <p><font size="3">Rather than passing all parameters
        explicitly the wwCGIProcess object - the class DevConDemo
        is derived from - the CGIProcess object contains an
        embedded CGI object property named oCGI. This object
        property encapsulates all the information passed by the
        Web server as contained in the INI content file that is
        created by the ISAPI dll. The format of the INI file is
        similar to the FoxISAPI implementation, but it follows
        the Windows CGI specification rather than using a
        proprietary format used by FoxISAPI.</font></p>
        <p><font size="3">The CGI object encapsulates the CGI
        variables and provides predefined methods for the most
        common server variables. Here are a few: <i>GetBrowser,
        GetServerName, GetPreviousURL, IsSecure, IsHTML30,
        GetCookie, SetOLEClass</i> just to name a few. You can
        also parse out 'parameters' from the URL using the <i>GetCGIParameter</i>
        method which takes a numeric argument to return an entry
        from the Querystring. For example, if you have <b>wwcgi.dll?MyPrg~MyMethod~Parm1~Parm2</b>
        and you wanted to retrieve the Parm2 parameter you'd use <b>loCGI.GetCGIParameter(4)</b>
        to retrieve the value (&quot;Parm2&quot; in this case).</font></p>
        <p><font size="3">The CGI object also retrieves form
        variables that were entered on HTML forms. To retrieve
        form variables you simply call <b>GetFormVar(&quot;UserId&quot;</b><i>)</i>
        to retrieve a form variable by the name of UserId.
        Multiple selections are parsed into an array and can be
        retrieved with <b>loCGI.GetFormMultiple(aValues,&quot;MultiFieldname&quot;).</b></font></p>
        <p><font size="3">In order to simplify HTML output an
        HTML class is provided that abstracts the output
        mechanism. As with the CGI object an HTML object property
        is automatically created with the CGIProcess object when
        your processing routine is called. It can be referenced
        as THIS.oHTML and is already set to output to the
        appropriate output device. The HTML class provides many
        high and low level methods to handle output of HTML. </font></p>
        <p><font size="3">At the low level the <b>Send</b>()
        method is used for <b>ALL </b>output including any output
        sent by the internal methods. This is done so you can
        change HTML output mechanism without changing any code.
        The HTML class supports output to file, string and
        optimized string (dumps to file when the buffer gets too
        big which can drastically speed string processing on
        large strings).</font></p>
        <p><font size="3">Many high level methods of the HTML
        class make short work of creating HTML under program
        control. You can see a few examples in the code snippet. <b>HTMLHeader()</b>
        creates a starter page header including HTTP header,
        Title and a standard HTML header. The CGIProcess Class' <b>ErrorMsg()</b>
        method creates a freestanding HTML page with a single
        method call. Simply pass a header and message text to be
        displayed and a full page is sent back to the Web server.</font></p>
        <p><font size="3"><b>ShowCursor()</b> is a very handy
        method for displaying an entire table/cursor as an HTML
        table with a single call. <b>ShowMemoPage()</b> can
        display HTML documents stored on disk or in a memo field.
        The pages can also contain embedded Visual FoxPro
        character expressions which are expanded as the page is
        loaded and sent back to the Web server for display. This
        feature is very handy and important as you can use
        standard HTML editors to create your HTML layout, then
        simply embed fields and characters variables, and even
        entire expressions and code blocks directly into the
        page. Here's an example:</font></p>
        <pre>##FOXCODE
PUBLIC wcClientName
wcClientName=UPPER(poCGI.GetFormVar(&quot;ClientName&quot;))
SELECT Company, Phone FROM TT_CUST ;
  WHERE upper(company)=wcClientName ;	
  INTO Cursor Tquery ORDER BY COMPANY

*** Always return a string
RETURN &quot;&quot;##

&lt;HTML&gt;
&lt;HEAD&gt;&lt;TITLE&gt;Client List&lt;/TITLE&gt;&lt;/HEAD&gt;
&lt;BODY BACKGROUND=&quot;/wconnect/whitwav.jpg&quot;&gt;
&lt;H1&gt;Queried for: ##wcClientName## &lt;/H1&gt;
&lt;HR&gt;
First Record Company: ##Tquery.company##&lt;BR&gt;
  First Record Phone: ##Tquery.Phone##&lt;p&gt; 
&lt;CENTER&gt;

&lt;!-- HTML Method to display a table in full --&gt;
##poHTML.ShowCursor(,,,.T.)##

&lt;/CENTER&gt;&lt;HR&gt;

&lt;/BODY&gt;&lt;/HTML&gt;

##FOXCODE
*** Cleanup Code -Always release PUBLIC VARIABLES
RELEASE wcClientName
USE IN TQUERY
*** MUST ALWAYS RETURN STRING!
RETURN &quot;&quot;
##</pre>
        <p><font size="3">Any character expressions can be
        embedded within the ## pairs. If the expression contained
        within is invalid an error message is embedded in the
        document instead. Note the call to poHTML.ShowCursor() -
        UDF() calls are valid and the poHTML object is available
        in ShowMemoPage() parsed pages to help with inline HTML
        generation.</font></p>
        <p><font size="3">##FOXCODE can be used to embed entire
        code blocks into pages - however, doing so is rather slow
        and not recommended - it's much more efficient to create
        a separate UDF() and call it from the page rather than
        using the inline code block. Expressions work with all
        versions of Visual FoxPro but the FOXCODE option requires
        the Development version.</font></p>
    </blockquote>
</blockquote>

<p><font color="#800040" size="5" face="Arial"><b>Conclusion</b></font></p>

<blockquote>
    <ul>
        <li><font face="Arial"><b>Check out Active Server for
            sophisticated server scripting <br>
            and connectivity to VFP via Automation servers<br>
            </b></font></li>
        <li><font face="Arial"><b>For more control use Visual
            FoxPro as a Web data server<br>
            </b></font></li>
        <li><font face="Arial"><b>FoxISAPI provides powerful OLE
            connectivity with an easy interface<br>
            </b></font></li>
        <li><font face="Arial"><b>For a complete Fox based Web
            environment check out Web Connection</b></font></li>
    </ul>
</blockquote>

<hr>

<p><a href="/wwcgi.asp"><font size="2" face="ARIAL"><img
src="../wcpower.gif" alt="Powered by Web Connection" align="left"
border="0" hspace="5" width="119" height="42"></font></a> <a
href="http://www.microsoft.com/IE/"><font size="2" face="ARIAL"><img
src="../IMAGES/ielogo.gif"
alt="Best viewed with Internet Explorer" align="right" border="0"
hspace="0" width="88" height="31" valign="TOP"></font></a> <font
size="2" face="ARIAL"><i>This page has been visited </i></font><font
size="2"><strong><!--webbot bot="HTMLMarkup" startspan -->
  <% =oWebTools.IncCounter("DevCon01") %>
<!--webbot
bot="HTMLMarkup" endspan --></strong></font><font size="2"
face="ARIAL"> <em>times since November 9, 1996<br>
Last updated: 02/10/97 <br>
[Back to </em></font><a href="/"><font size="2" face="ARIAL"><em>West
Wind Technologies</em></font></a><font size="2" face="ARIAL"><em>]</em></font></p>
<!--#include file="../BrowserCapability.asp" --></body>
</html>
